
<div class="container bd" id="hdiv">
    <h1>代码效率测试</h1>
    <div class="col-sm-6">
        <textarea style="width: 100%; height: 200px; " v-model="code1"></textarea>
    </div>
    <div class="col-sm-6">
        <textarea style="width: 100%; height: 200px; " v-model="code2"> </textarea>
    </div>
    <div class="container text-center">
        <input type="button" value=" Test " @click="test">
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" id="hpre1">{{code1}}</pre>
        {{result1}}
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" id="hpre2">{{code2}}</pre>
        {{result2}}
    </div>
</div>
<div class="container demo">
    <h1>数组去重</h1>
    
    
    <div class="col-sm-6">
        <pre et type="text/javascript" >
// for...of + includes()
let arr1 = Array.from(new Array(100000), (x, index)=>{
    return index
})

let arr2 = Array.from(new Array(50000), (x, index)=>{
    return index+index
})
function distinct(a, b) {
    let arr = a.concat(b)
    let result = []
    for (let i of arr) {
        !result.includes(i) && result.push(i)
    }
    return result
}

distinct(arr1, arr2);            
        </pre>
        <div class="result"></div>
        <input type="button" value=" Test " >
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
// Array.sort()
let arr1 = Array.from(new Array(100000), (x, index)=>{
    return index
})

let arr2 = Array.from(new Array(50000), (x, index)=>{
    return index+index
})
function distinct(a, b) {
    let arr = a.concat(b)
    arr = arr.sort()
    let result = [arr[0]]

    for (let i=1, len=arr.length; i&lt;len; i++) {
        arr[i] !== arr[i-1] && result.push(arr[i])
    }
    return result
}

distinct(arr1, arr2);            
        </pre>
        <div class="result"></div>
        <input type="button" value=" Test " >
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
// new Set()
let arr1 = Array.from(new Array(100000), (x, index)=>{
    return index
})

let arr2 = Array.from(new Array(50000), (x, index)=>{
    return index+index
})
function distinct(a, b) {
    return Array.from(new Set([...a, ...b]))
}

distinct(arr1, arr2);            
        </pre>
        <div class="result"></div>
        <input type="button" value=" Test " >
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
// for...of + Object
let arr1 = Array.from(new Array(100000), (x, index)=>{
    return index
})

let arr2 = Array.from(new Array(50000), (x, index)=>{
    return index+index
})
function distinct(a, b) {
    let arr = a.concat(b)
    let result = []
    let obj = {}

    for (let i of arr) {
        if (!obj[i]) {
            result.push(i)
            obj[i] = 1
        }
    }

    return result
}

distinct(arr1, arr2);            
        </pre>
        <div class="result"></div>
        <input type="button" value=" Test " >
    </div>
        
</div>
<script>
    new Vue({
        el : '#hdiv'
        , data : {result1:'', result2:''
            , code1:'Array.from(new Array(10000000), function(v, i){ return i;})'
            , code2:'var arr=[]; for(var i=0; i<10000000; i++){arr.push(i); }'
        }
        , methods:{
            test : function(){
                var _me = this;
                this.result1 = showResult({
                    timeConsuming: ET.timeConsuming(function(){ET.execJS(_me.code1)})
                });
                this.result2 = showResult({
                    timeConsuming: ET.timeConsuming(function(){ET.execJS(_me.code2)})
                });
                hpre1.innerText = this.code1;
                hpre2.innerText = this.code2;
            }
        }
    });
    function showResult(data){
        return '所用时间：'+data.timeConsuming+'毫秒'
    }
    
    function demo(){
        $('.demo').each(function(){
            var _me = this;
            $(_me).find('pre').each(function(){
                var pre = this, p = $(this).parent();
                p.find('input').click(function(){
                    var _me=this, ret = showResult({
                        timeConsuming : ET.timeConsuming( function(){ ET.execJS(pre.innerText); })
                    });
                    console.log(ret);
                    p.find('.result').html(ret);

                });

            });
        });
    }
    $(function(){ demo(); });
</script>
